# Export Functions

## Gargantext V3

### abstract as html file as in template merging treatments and outcome
garg_export_with_html <- function(df,filename) {
  x <- data.frame("publication_day"=day(as.Date(df$Registration.date,"%Y-%m-%d")))
  x$publication_month = month(as.Date(df$Registration.date,"%Y-%m-%d"))
  x$publication_year = year(as.Date(df$Registration.date,"%Y-%m-%d"))
  x$authors=df$First.author
  x$title=df$Trial.registration.number
  x$source=df$Funding
  x$abstract=paste("<a href='",df$Full.text.link,"' target='blank'>Link to study</a></br></br><b> ",df$Study.design," (</b>",df$Recruitment.status,")</br></br><b>TYPE OF PATIENTS:</b> ",df$Type.of.patients,"</br></br><b>",toupper(df$Pharmacological.treatment),"</b></br><i>Type: </i>",df$Treatment.type,"</br><i> Treatment name: </i>",str_replace_all(tolower(df$Treatment.name),"[[+]]"," + "),"</br></br><b>PRIMARY OUTCOME</b></br>",df$primary.outcome,"</br></br><b>",df$Center,"</b> (",df$Countries,")</br><b>N in this treatment group:</b> ",df$n.randomized.in.this.arm," </br><b>N in the trial: </b>",df$Total.sample.size)

  write.table(x, file = paste("../data/gargCSV_all_html_",filename,".csv",sep = ""), sep = "\t",row.names = FALSE)
}

garg_export_treatments_with_html <- function(df,filename) {
  x <- data.frame("publication_day"=day(as.Date(df$Registration.date,"%Y-%m-%d")))
  x$publication_month = month(as.Date(df$Registration.date,"%Y-%m-%d"))
  x$publication_year = year(as.Date(df$Registration.date,"%Y-%m-%d"))
  x$authors=df$First.author
  x$title=df$Trial.registration.number
  x$source=df$Funding
  x$abstract=paste("<a href='",df$Full.text.link,"' target='blank'>Link to study</a></br></br><b> ",toupper(df$Pharmacological.treatment),"</b></br><i>Type: </i>",df$Treatment.type,"</br><i> Treatment name: </i>",str_replace_all(tolower(df$Treatment.name),"[[+]]"," + "))
  write.table(x, file = paste("output/gargCSV_Treatments_html_",filename,".csv",sep = ""), sep = "\t",row.names = FALSE)
}

garg_export_raw_treatments<- function(df,filename) {
  x <- data.frame("publication_day"=day(as.Date(df$Registration.date,"%Y-%m-%d")))
  x$publication_month = month(as.Date(df$Registration.date,"%Y-%m-%d"))
  x$publication_year = year(as.Date(df$Registration.date,"%Y-%m-%d"))
  x$authors=df$First.author
  x$title=df$Trial.registration.number
  x$source=df$Funding
  x$abstract=paste(toupper(df$Pharmacological.treatment)," . ",df$Treatment.type," . ",str_replace_all(tolower(df$Treatment.name),"[[+]]"," ; "))
  write.table(x, file = paste("output/gargCSV_Treatments_raw_",filename,".csv",sep = ""), sep = "\t",row.names = FALSE)
}


garg_export_all_plain <- function(df,filename) {
  x <- data.frame("publication_day"=day(as.Date(df$Registration.date,"%Y-%m-%d")))
  x$publication_month = month(as.Date(df$Registration.date,"%Y-%m-%d"))
  x$publication_year = year(as.Date(df$Registration.date,"%Y-%m-%d"))
  x$authors=df$First.author
  x$title=df$Trial.registration.number
  x$source=df$Funding
  x$abstract=paste("Link to study: ",df$Full.text.link," DESIGN: ",df$Study.design,", RECRUITEMENT STATUS: ",df$Recruitment.status,", TYPE OF PATIENTS: ",df$Type.of.patients," TREATMENT: ",toupper(df$Pharmacological.treatment),", TYPE: ",df$Treatment.type,", TREATMENT NAME: ",str_replace_all(tolower(df$Treatment.name),"[[+]]"," + "),", PRIMARY OUTCOME: ",df$primary.outcome,", CENTER: ",df$Center,", COUNTRY: ",df$Countries,", N in this treatment group: ",df$n.randomized.in.this.arm,", N in the trial: ",df$Total.sample.size)
  
  write.table(x, file = paste("output/gargCSV_all_plain_",filename,".csv",sep = ""), sep = "\t",row.names = FALSE)
}

garg_export_OnlyTreatments <- function(df,filename) {
  x <- data.frame("publication_day"=day(as.Date(df$Registration.date,"%Y-%m-%d")))
  x$publication_month = month(as.Date(df$Registration.date,"%Y-%m-%d"))
  x$publication_year = year(as.Date(df$Registration.date,"%Y-%m-%d"))
  x$authors=df$Full.text.link
  x$title=df$Trial.registration.number
  x$source=df$Funding
  x$abstract=paste(" TREATMENT: ",toupper(df$Pharmacological.treatment),", TYPE: ",df$Treatment.type,", TREATMENT NAME: ",str_replace_all(tolower(df$Treatment.name),"[[+]]"," + "))
  
  write.table(x, file = paste("output/gargCSV_only_treatment_plain",filename,".csv",sep = ""), sep = "\t",row.names = FALSE)
}

garg_export_OnlyOutcomes <- function(df,filename) {
  x <- data.frame("publication_day"=day(as.Date(df$Registration.date,"%Y-%m-%d")))
  x$publication_month = month(as.Date(df$Registration.date,"%Y-%m-%d"))
  x$publication_year = year(as.Date(df$Registration.date,"%Y-%m-%d"))
  x$authors=df$Full.text.link
  x$title=df$Trial.registration.number
  x$source=df$Funding
  x$abstract=paste("PRIMARY OUTCOME: ",df$primary.outcome)
  write.table(x, file = paste("output/gargCSV_only_outcomes_plain",filename,".csv",sep = ""), sep = "\t",row.names = FALSE)
}

# Export de listes de termes

getTreatmentsList <- function(df){
## fait juste la liste des treatments en partant du fait qu'ils sont séparé par des + dans la colonne treatments  
  y<-paste(df$Treatment.name,collapse = "+")
  z<-data.frame("treatments"=strsplit(str_replace_all(tolower(y),"[[+]]","&"),"&")[[1]])
}

gargV3_export_treaments_list <- function(df,filename) {
## Export de la liste de tous les traitements pour import dans gargantextV3
y<-paste(AllData$Treatment.name,collapse = "+")
z<-data.frame("label"=unique(strsplit(str_replace_all(tolower(y),"[[+]]","&"),"&")[[1]]))
z$forms=z$label
write.table(z, file = paste("output/WL_GargV3_clinicaltrialsTreatments.csv",sep = ""), sep = "\t",row.names = FALSE,quote = FALSE)
}

gargV4_export_treaments_list <- function(df,filename) {
## Export de la liste de tous les traitements pour import dans gargantextV4 sur la base de traitements séparés par des + dans la bdd originale
t=getTreatmentsList(df)
output<-paste('"',t$treatments,'":{"size":1,"list":"GraphTerm","children":[]}')
output<-paste('{"NgramsTerms":{"version":1237,"data":{',paste(output,collapse =','),"}}}")      
write.table(output, file = paste("output/WL_GargV4_CT_treaments_",filename,".json",sep = ""), sep = "",row.names = FALSE,quote = FALSE)
}

ColumnTextCount <- function(df,column){
  y<-paste(df$Treatment.name,collapse = "+")
  z<-data.frame("treatments"=strsplit(str_replace_all(tolower(y),"[[+]]","&"),"&")[[1]])
}

## Visualization functions
TreatmentsCloud <- function(df){
  treatments_list<-getTreatmentsList(df)
  words=treatments_list %>% count(treatments)
  set.seed(1234)
  wordcloud(words = words$treatments, freq = words$n, min.freq =2,
            max.words=400, random.order=FALSE, rot.per=0.35, 
            colors=brewer.pal(8, "Dark2"))
}
